'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _DatePicker = require('rmc-date-picker/lib/DatePicker.js');

var _DatePicker2 = _interopRequireDefault(_DatePicker);

var _moment = require('moment/moment');

var _moment2 = _interopRequireDefault(_moment);

var _uxMPlatformPopup = require('ux-m-platform-popup');

var _uxMPlatformPopup2 = _interopRequireDefault(_uxMPlatformPopup);

var _uxMPlatformFooter = require('@beisen-cmps/ux-m-platform-footer');

var _uxMPlatformFooter2 = _interopRequireDefault(_uxMPlatformFooter);

var _uxMPlatformButton = require('@beisen-cmps/ux-m-platform-button');

var _uxMPlatformButton2 = _interopRequireDefault(_uxMPlatformButton);

var _zh_CN = require('./zh_CN');

var _zh_CN2 = _interopRequireDefault(_zh_CN);

require('./index.css');

require('rmc-picker/assets/index.css');

require('rmc-date-picker/assets/index.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// let map = {
// 		'yyyy/MM/dd HH:mm:ss' : "datetime"
// 		,'yyyy/MM/dd' : 'date'
// 		,'yyyy/MM' : 'month'
// 		,'HH:mm' : "time"
// 	}

var BlockDatePicker = (_temp = _class = function (_React$Component) {
	(0, _inherits3.default)(BlockDatePicker, _React$Component);

	function BlockDatePicker() {
		(0, _classCallCheck3.default)(this, BlockDatePicker);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		var _this = (0, _possibleConstructorReturn3.default)(this, _React$Component.call.apply(_React$Component, [this].concat(args)));

		_this.elementClientTop = 0;
		_this.state = {
			isOpen: false,
			selectedDate: (0, _moment2.default)()
		};
		_this.selectedDate = (0, _moment2.default)();
		_this.lastConfirmDate = _this.state.selectedDate.clone();
		return _this;
	}

	BlockDatePicker.prototype.componentDidMount = function componentDidMount() {
		if (this.refs.blockDatepicker) {
			this.elementClientTop = this.refs.blockDatepicker.getBoundingClientRect().top;
			this.$el = _reactDom2.default.findDOMNode(this);
			this.$el.addEventListener('touchmove', function (evt) {
				evt.stopPropagation();
			}, false);
		}
	};

	BlockDatePicker.prototype.componentWillReciveprops = function componentWillReciveprops(nextProps) {
		var newDate = (0, _moment2.default)(nextProps.currentDate);
		if (!this.state.selectedDate.isSame()) {
			this.state.setState({ selectedDate: newDate });
		}
	};

	BlockDatePicker.prototype.componentDidUpdate = function componentDidUpdate() {
		if (this.state.isOpen) {
			document.body.classList.add('popup-active');
		} else {
			document.body.classList.remove('popup-active');
		}

		if (this.refs.blockDatepicker) {
			this.elementClientTop = this.refs.blockDatepicker.getBoundingClientRect().top;
		}
	};

	BlockDatePicker.prototype.componentWillUnMount = function componentWillUnMount() {
		this.$el && this.$el.removeEventListener('touchmove', function (evt) {
			evt.stopPropagation();
		}, false);
	};

	BlockDatePicker.prototype.displayFormat = function displayFormat(date) {
		switch (this.props.mode) {
			case 'month':
				return date.year() + '\u5E74' + (date.month() + 1) + '\u6708';
			case 'date':
				return date.year() + '\u5E74' + (date.month() + 1) + '\u6708' + date.date() + '\u65E5';
			default:
				return '';
		}
	};

	BlockDatePicker.prototype.handleClick = function handleClick() {
		this.setState({ isOpen: !this.state.isOpen });
	};

	BlockDatePicker.prototype.handleCancel = function handleCancel() {
		this.setState({ isOpen: false, selectedDate: this.lastConfirmDate });
	};

	BlockDatePicker.prototype.handleConfim = function handleConfim() {
		this.setState({ isOpen: false }, function () {
			this.lastConfirmDate = this.selectedDate;
			this.props.onDateChange && this.props.onDateChange(this.selectedDate);
		});
	};

	BlockDatePicker.prototype.handleDateChange = function handleDateChange(dateObj) {
		this.selectedDate = dateObj;
		this.setState({ selectedDate: this.selectedDate });
	};

	BlockDatePicker.prototype.getContainer = function getContainer() {
		return this.refs.popContainer;
	};

	BlockDatePicker.prototype.render = function render() {
		return _react2.default.createElement(
			'div',
			{ ref: 'blockDatepicker' },
			_react2.default.createElement(
				'div',
				{
					className: 'datepicker-block',
					onTouchTap: this.handleClick.bind(this)
				},
				_react2.default.createElement(
					'span',
					{ className: 'datepicker-title' },
					this.props.displayFormat ? this.props.displayFormat(this.state.selectedDate) : this.displayFormat(this.state.selectedDate)
				),
				_react2.default.createElement('span', { className: 'datepicker-arrow' })
			),
			_react2.default.createElement('div', { ref: 'popContainer' }),
			_react2.default.createElement(
				_uxMPlatformPopup2.default,
				{
					ref: 'popup',
					visible: this.state.isOpen,
					animation: 'topTool-slide-fade',
					maskAnimation: 'fade',
					onClose: this.handleCancel.bind(this),
					isFullPage: true,
					maskStyle: { zIndex: '1', top: this.elementClientTop },
					style: { top: '44px' },
					wrapClassName: 'datepicker_wrap',
					getContainer: this.getContainer.bind(this)
				},
				_react2.default.createElement(
					'div',
					null,
					_react2.default.createElement(_DatePicker2.default, {
						date: this.state.selectedDate,
						mode: this.props.mode,
						locale: (0, _zh_CN2.default)(this.props.mode),
						minDate: this.props.minDate || (0, _moment2.default)([1900, 1, 1, 0, 0, 0]),
						maxDate: this.props.maxDate || (0, _moment2.default)([2050, 1, 1, 23, 59, 59]),
						onDateChange: this.handleDateChange.bind(this)
					}),
					_react2.default.createElement(
						_uxMPlatformFooter2.default,
						{ cls: 'searchItem-footer-border' },
						_react2.default.createElement(_uxMPlatformButton2.default, { cls: 'btn_empty', text: '\u53D6\u6D88', onTouchTap: this.handleCancel.bind(this) }),
						_react2.default.createElement(_uxMPlatformButton2.default, { cls: 'btn_submit', text: '\u786E\u5B9A', onTouchTap: this.handleConfim.bind(this) })
					)
				)
			)
		);
	};

	return BlockDatePicker;
}(_react2.default.Component), _class.defaultProps = {
	mode: 'date',
	currentDate: new Date()
}, _temp);
exports.default = BlockDatePicker;
module.exports = exports['default'];